using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace Pluunty
{
    /// <summary>
    /// Object that represents a on screen pointer.
    /// </summary>
    public class PointerItem
    {
        /// <summary>
        /// Holds a reference to a AnimationSet object used to animate the pointerItem.
        /// </summary>                                                            
        private zeeAni.AnimationSet<string, zeeAni.SpriteFrame> ani;
        /// <summary>
        /// Holds the name given to the pointer.
        /// </summary>
        private string name;

        /// <summary>
        /// Gets/Sets the name of the pointer.
        /// </summary>
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        /// <summary>
        /// Gets/Sets the AnimationSet object used to animate the pointer.
        /// </summary>
        public zeeAni.AnimationSet<string, zeeAni.SpriteFrame> Animation
        {
            get { return ani; }
            set { ani = value; }
        }
    }
}
